SystemOrganization addCategory: #'tODE-Core'!

Notification subclass: #TOAbortCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

Notification subclass: #TOErrorCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

Object subclass: #TOObject
	instanceVariableNames: 'object properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:19'!
actualClass

	^self object class! !

!TOObject methodsFor: 'evaluation' stamp: 'dkh 5/28/2011 13:34'!
inspectit: aString main: main

	self pushit: (self doit: aString main: main) selecting: #inspect main: main! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object
	^ object! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object: anObject
	object := anObject! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties

	properties ifNil: [ properties := Dictionary new ].
	^ properties! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties: anObject
	properties := anObject! !

!TOObject methodsFor: 'evaluation' stamp: 'dkh 5/28/2011 13:34'!
pushit: anObject selecting: aSymbol main: main

	main currentSpace push: anObject selecting: aSymbol! !

!TOObject methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:43'!
renderButton: renderBlock label: label on: html
	(html submitButton)
		onClick: (html jQuery ajax script: [ :s | renderBlock value: s ]);
		with: label! !

!TOObject methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:15'!
renderControl: aBlock on: html
	| id |
	id := html nextId.
	html fieldSet: [
		html span: [
			aBlock
				value: id
				" update the paragraph "
				value: ((html jQuery this	
					parents: 'fieldset';
					find: 'p') load
						" serialize all nearby form elements "
						serialize: (html jQuery this		
							parents: 'span';
							find: ':input')) ]]! !

!TOObject methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:15'!
renderLink: block with: labelRenderer on: html

	| id |
	id := html nextId.
	(html anchor)
		url: '#';
		id: id;
		onClick:
			(html jQuery ajax
				script: [ :s | block value: s ]);
		with: labelRenderer! !

TOObject subclass: #TOObjectFrame
	instanceVariableNames: 'selectedCenterTab centerTabSpec label space'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObjectFrame methodsFor: 'private' stamp: 'dkh 5/23/2011 23:21'!
calculateCenterTabSpec
	| currentObject specs groups grouped ids |
	currentObject := self object.
	ids := IdentitySet new.
	specs := {self frameTabSpec} , ((Pragma allNamed: #tODECenterTabSpec from: currentObject class to: nil) reversed
		collect: [ :pragma | 
			(currentObject perform: pragma method selector)
				frame: self;
				yourself ]).
	specs
		select: [ :each | 
			(ids includes: each id)
				ifTrue: [ false ]
				ifFalse: [ 
					ids add: each id.
					true ] ].
	groups := (specs collect: [ :ea | ea group ]) asSet asSortedCollection: [ :a :b | a < b ].
	grouped := groups
		collect: [ :ea | (specs select: [ :b | b group = ea ]) asSortedCollection: [ :a :b | a order <= b order ] ].
	^ grouped gather: [ :ea | ea ]! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:50'!
centerTabSpec

	centerTabSpec ifNil: [ centerTabSpec := self calculateCenterTabSpec ].
	^centerTabSpec ! !

!TOObjectFrame methodsFor: 'private' stamp: 'dkh 5/29/2011 11:06'!
frameTabSpec

	^ (TOTabSpec new)
		id: #tODE;
		renderer: self;
		receiver: self;
		frame: self;
		label: 'tODE';
		order: 50;
		group: 'tODE';
		renderSelector: #renderFrameTabOn:spec:tOdeMain:! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:24'!
historyLabel

	^self object printStringLimitedTo: 50! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:43'!
label

	label ifNil: [ label := 'tODE frame'].
	^label! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:18'!
label: aString

	label := aString! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 5/28/2011 11:09'!
renderFrame: index on: html main: main
	self
		renderLink: [ :s | 
			main currentSpace push: self object selecting: self selectedCenterTab.
			main updateCenterSideHistory: s ]
		with: [ html strong: index printString , '. ' ]
		on: html.
	html text: self historyLabel! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 5/29/2011 11:06'!
renderFrameTabOn: html spec: aTOSpecTab tOdeMain: main
	| members inspector |
	inspector := TOInspector new.
	html
		break;
		strong: self label;
		text: ' for ' , self historyLabel;
		break;
		break.
	inspector
		renderBasicMembers:
			({('root' -> TORoot current).
			('frame' -> self).
			('object' -> self object).
			('main' -> main)} collect: [ :each | each asKeylessFieldSpec ])
		on: html
		main: main.
	html break.
	html strong: 'frame properties:'.
	members := (self properties associations sorted: [:a :b | a key <= b key ]) collect: [ :each | each asKeylessFieldSpec ].
	html unorderedList: [ inspector renderBasicMembers: members on: html main: main ]! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:37'!
rendererForCenterTab: aSymbol
	self centerTabSpec
		do: [ :spec | 
			spec id == aSymbol
				ifTrue: [ ^ spec renderer ] ].
	^ nil! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTab

	^selectedCenterTab ! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTab: aSymbol

	^selectedCenterTab := aSymbol! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTabIndex
	| selectedTab |
	selectedTab := self selectedCenterTab.
	self centerTabSpec
		withIndexDo: [ :spec :i | 
			spec id == selectedTab
				ifTrue: [ ^ i - 1 ] ].
	^ 0! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:59'!
sidebarSpec
	| specs |
	specs := (self centerTabSpec at: self selectedCenterTabIndex + 1) sidebarSpec.
	specs do: [:spec | spec frame: self ].
	^specs! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 12:02'!
space
	^ space! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 12:02'!
space: anObject
	space := anObject! !

TOObject subclass: #TOView
	instanceVariableNames: 'frame ctlKeyPressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:16'!
frame
	^ frame! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:16'!
frame: anObject
	frame := anObject! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:25'!
renderClassHeading: aClass on: html main: main

	self renderSuperclassHeading: aClass on: html main: main.
! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/26/2011 13:53'!
renderSuperclassHeading: aClass on: html main: main
	self sharedClassState
		renderSuperclassHeading: aClass
		on: html
		main: main! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass
	^self sharedClassState selectedSuperclass! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass: anObject
	self sharedClassState selectedSuperclass: anObject! !

!TOView methodsFor: 'events' stamp: 'dkh 5/26/2011 13:47'!
selectedSuperclassChanged! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 09:09'!
sharedClassState
	^ self frame properties
		at: #sharedClassState
		ifAbsent: [ 
			self frame properties
				at: #sharedClassState
				put:
					((TOSharedClassState new)
						object: self object;
						frame: self frame;
						yourself) ]! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 14:42'!
textAreaColumns

	| lineWidth src tab |
	lineWidth := 0.
	tab := Character tab.
	(src := self methodSource) linesDo: [:line | | tabs |
		tabs := 0.
		line do: [:char | char = tab ifTrue: [ tabs := tabs + 5 ]].
		lineWidth := lineWidth max: (line size + tabs)].
	^lineWidth! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 14:43'!
textAreaColumns: text

	| lineWidth tab |
	lineWidth := 0.
	tab := Character tab.
	text linesDo: [:line | | tabs |
		tabs := 0.
		line do: [:char | char = tab ifTrue: [ tabs := tabs + 5 ]].
		lineWidth := lineWidth max: (line size + tabs)].
	^lineWidth! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 14:43'!
textAreaRows: text

	| lineCount |
	lineCount := 0.
	text linesDo:[:line | lineCount := lineCount + 1 ].
	^lineCount! !

!TOView methodsFor: 'accessing' stamp: 'dkh 05/27/2011 11:46'!
theClass

	^self selectedSuperclass ifNil: [ self actualClass ]! !

Object subclass: #TORoot
	instanceVariableNames: 'currentSpace'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'tODE-Core'!

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
current

	Current ifNil: [ Current := self new ].
	^Current ! !

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
reset
	"self reset"

	Current := nil! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:40'!
currentFrame

	^self currentSpace currentFrame! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:30'!
currentSpace 

	currentSpace ifNil: [ currentSpace := TOSpace new ].
	^currentSpace ! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:42'!
history
	^self currentSpace history! !

Object subclass: #TOSpace
	instanceVariableNames: 'homeFrame currentFrame history frameStack frameStackIndex inverseFrameMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOSpace methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:31'!
back
	"set the currentFrame to the previous frame on the frame stack and record in history"

	| frame |
	self frameStackIndex <= 1 ifTrue: [ ^currentFrame ].
	frameStackIndex := self frameStackIndex - 1.
	frame := self frameStack at: frameStackIndex.
	self history addLast: frame.
	^currentFrame := frame! !

!TOSpace methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 11:19'!
bookmark

	self push: 'not yet implemented' selecting: #inspect! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:24'!
currentFrame
	currentFrame
		ifNil: [ currentFrame := self pushFrame: self homeFrame ].
	^ currentFrame! !

!TOSpace methodsFor: 'private' stamp: 'dkh 5/22/2011 18:58'!
findFrameFor: anObject
	^self inverseFrameMap
		at: anObject
		ifAbsent: [ 
			self inverseFrameMap
				at: anObject
				put:
					(self newFrameFor: anObject) ].
! !

!TOSpace methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:26'!
forward
	"set the currentFrame to the next frame on the frame stack and record in history"

	| frame |
	self frameStack size = self frameStackIndex ifTrue: [ ^currentFrame ].
	frameStackIndex := self frameStackIndex + 1.
	frame := self frameStack at: frameStackIndex.
	self history addLast: frame.
	^currentFrame := frame! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:01'!
frameStack
	
	frameStack ifNil: [frameStack := OrderedCollection new ].
	^frameStack ! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:06'!
frameStackIndex

	frameStackIndex ifNil: [ frameStackIndex := self frameStack size ].
	^frameStackIndex! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:57'!
history
	
	history ifNil: [history := OrderedCollection new ].
	^history ! !

!TOSpace methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:18'!
home
	"push the home frame on the frame stack and record in history"

	^self pushFrame: self homeFrame! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/29/2011 11:25'!
homeFrame
	homeFrame
		ifNil: [ 
			| dict |
			dict := (Dictionary new)
				at: 1 put: 'string';
				at: 2 put: 'string with embedded ''strings''. That''s James'' toy.';
				at: #symbol put: 2;
				at:
						{1.
							1.1.
							(3 / 4)}
					put: DateAndTime now;
				at: Object put: (MethodReference class: Object selector: #yourself);
				yourself.
			Smalltalk at: #WACounter ifPresent: [ :cl | dict at: 'counter' put: cl ].
			homeFrame := self findFrameFor: dict.
			(homeFrame rendererForCenterTab: #workspace) contents: 'self error: ''Hello World''' ].
	^ homeFrame! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:23'!
homeFrame: aFrame
	homeFrame := aFrame! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 18:51'!
inverseFrameMap

	inverseFrameMap ifNil: [ inverseFrameMap := IdentityDictionary new ].
	^inverseFrameMap! !

!TOSpace methodsFor: 'private' stamp: 'dkh 5/28/2011 12:02'!
newFrameFor: anObject
	^ (TOObjectFrame new)
		space: self;
		object: anObject;
		yourself! !

!TOSpace methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:18'!
push: anObject
	"push the frame for anObject onto the frameStack and record in history"

	^self pushFrame: (self findFrameFor: anObject)! !

!TOSpace methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 11:02'!
push: anObject selecting: aSymbol
	"push the frame for anObject onto the frameStack and record in history"

	| fr |
	fr := self findFrameFor: anObject.
	fr selectedCenterTab: aSymbol.  
	^self pushFrame: fr! !

!TOSpace methodsFor: 'private' stamp: 'dkh 5/28/2011 09:17'!
pushFrame: frame
	"push the frame onto the frameStack and record in history"

	|  index |
	self history addLast: frame.
	(index := self frameStackIndex) = self frameStack size
		ifFalse: [ frameStack := frameStack copyFrom: 1 to: index ].
	self frameStack addLast: frame.
	frameStackIndex := index + 1.
	^currentFrame := frame! !

!TOSpace methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 11:19'!
search

	self push: 'not yet implemented' selecting: #inspect! !

Object subclass: #TOTabSpec
	instanceVariableNames: 'id label group order priority renderSelector frame receiver sidebarSpec renderer rendererClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:08'!
frame
	^ frame! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:08'!
frame: anObject
	frame := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group
	^ group! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group: anObject
	group := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id
	^ id! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id: anObject
	id := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label
	^ label! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label: anObject
	label := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order
	^ order! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order: anObject
	order := anObject! !

!TOTabSpec methodsFor: 'printing' stamp: 'dkh 5/26/2011 11:47'!
printOn: aStream

	super printOn: aStream.
	aStream 
		nextPut: $(;
		nextPutAll: self label;
		nextPut: $)! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:06'!
receiver
	^ receiver! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:06'!
receiver: anObject
	receiver := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector
	^ renderSelector! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector: anObject
	renderSelector := anObject! !

!TOTabSpec methodsFor: 'rendering' stamp: 'dkh 5/29/2011 10:30'!
renderTabSpecContentOn: html main: main
	self receiver
		perform: self renderSelector
		withArguments:
			{html.
			self.
			main}! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/29/2011 11:20'!
renderer
	
	renderer
		ifNil: [ 
			self rendererClass ifNil: [ ^self receiver ]. 
			^self frame properties
				at: self id
				ifAbsent: [ 
					self frame properties
						at: self id
						put:
							((self rendererClass new)
								object: self receiver;
								frame: self frame;
								yourself) ] ].
	^renderer! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:35'!
renderer: anObject
	renderer := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:35'!
rendererClass
	^ rendererClass! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:35'!
rendererClass: anObject
	rendererClass := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:38'!
sidebarSpec
	sidebarSpec ifNil: [ ^#() ].
	^ sidebarSpec! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:38'!
sidebarSpec: anObject
	sidebarSpec := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:59'!
tabLabel
	
	label ifNil: [ ^self id asString ].
	^label! !
